package table_viewer;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.jface.viewers.ArrayContentProvider;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.ui.part.ViewPart;

/**
 * eXgʂ\r[
 */
public class TestResultView extends ViewPart {

    /**
     * RXgN^
     */
    public TestResultView() {
        super();
    }

    /**
     * ʂ̏
     */
    public void createPartControl(Composite parent) {
        // e[ur[A̐
        TableViewer testResultViewer = new TableViewer(parent, SWT.MULTI | SWT.VIRTUAL
                | SWT.H_SCROLL | SWT.V_SCROLL);
        
        // e[u̐
        Table testResultTable = testResultViewer.getTable();

        // Z̋Eɂ
        testResultTable.setLinesVisible(true);
        // wb_ɂ
        testResultTable.setHeaderVisible(true);

        // wb_ݒ
        TableColumn col = new TableColumn(testResultTable, SWT.LEFT);
        col.setText("oȔԍ");
        col.setWidth(80);

        col = new TableColumn(testResultTable, SWT.LEFT);
        col.setText("");
        col.setWidth(80);

        col = new TableColumn(testResultTable, SWT.RIGHT);
        col.setText("p");
        col.setWidth(80);

        col = new TableColumn(testResultTable, SWT.RIGHT);
        col.setText("w");
        col.setWidth(80);
        
        col = new TableColumn(testResultTable, SWT.RIGHT);
        col.setText("");
        col.setWidth(80);
        
        col = new TableColumn(testResultTable, SWT.RIGHT);
        col.setText("]");
        col.setWidth(80);
        
        // RecvoC_̐ݒ
        testResultViewer.setContentProvider( new ArrayContentProvider());
        // xvoC_̐ݒ
        testResultViewer.setLabelProvider( new TestResultLabelProvider());
        
        // f[^̐ݒ
        testResultViewer.setInput( getTestResult());
        
    }
    
    
    /**
     * _~[̕\f[^擾
     * @return eXgʂ̃Xg
     */
    private List getTestResult(){
        List resultList = new ArrayList(); 
        
        TestResult result = new TestResult();
        result.setId( 1);
        result.setName("X ms");
        result.setEnglishScore( getRandom());
        result.setMathematicsScore( getRandom());
        result.setJapaneseScore( getRandom());
        resultList.add( result);
        
        result = new TestResult();
        result.setId( 2);
        result.setName(" N");
        result.setEnglishScore( getRandom());
        result.setMathematicsScore( getRandom());
        result.setJapaneseScore( getRandom());
        resultList.add( result);
        
        result = new TestResult();
        result.setId( 3);
        result.setName("쑺@");
        result.setEnglishScore( getRandom());
        result.setMathematicsScore( getRandom());
        result.setJapaneseScore( getRandom());
        resultList.add( result);
         
        result = new TestResult();
        result.setId( 4);
        result.setName("ɓ@");
        result.setEnglishScore( getRandom());
        result.setMathematicsScore( getRandom());
        result.setJapaneseScore( getRandom());
        resultList.add( result);
        
        return resultList;
    }
    
    /**
     * 0`100̃_ȐlԂ\bh
     * @return 0`100̃_Ȑl
     */
    private int getRandom(){
        double random = Math.random();
        return (int)(random * 100);
    }

    public void setFocus() {
    }
}
